//##################################################################
// SimpleExpressions
//##################################################################

#include SimpleExpressions.h

#define SIGNEDOP

#define STACKSIZE 60
#define CALC_FAIL -2
#define CALC_SUCCESS -1
#define CALC_DIVBYZERO -3
#define CALC_OVERFLOW -4
#define TRUE 1
#define FALSE 0

// enum CALC_SYMBOLS_TAG
CALC_SYMBOL_OR=0 // |
CALC_SYMBOL_AND=1 // &
CALC_SYMBOL_XOR=2 // ^
CALC_SYMBOL_MULTIPLY=3 // *
CALC_SYMBOL_DIVIDE=4 // /
CALC_SYMBOL_ADD=5 // +
CALC_SYMBOL_SUBTRACT=6 // -
CALC_SYMBOL_NOT=7 // !
CALC_SYMBOL_OPEN=8  // (
CALC_SYMBOL_CLOSE=9 // )
CALC_SYMBOL_NUMBER=10
CALC_SYMBOL_INVALID=11

STACKENTRY STRUCT
	var INT32
	sym ENUM // CALC_SYMBOLS
ENDS

DATA SECTION
	StackIndex DD 0
	solution DD 0
	szSolution DB 256 DUP (?)
	StackBuffer STACKENTRY STACKSIZE DUP <0,0>

CODE SECTION

START:

// Left to right only no precedence
invoke calculate,"4*-15",offset solution
cmp eax,CALC_SUCCESS
jne >
	invoke dw2a,[solution],offset szSolution
	invoke MessageBox,NULL,offset szSolution,"Solution",NULL
:
invoke ExitProcess,0

dw2a FRAME dwValue,lpBuffer
	uses ebx,edi

	; MichaelW w/ PDixon

		mov eax,[dwValue]
		mov ecx,2814749768
		mov edi,[lpBuffer]

		or eax,eax
		jns >S1
		neg eax
		mov B[edi],"-"
		inc edi

S1:
	push eax
;	#####fast div by 100000
		mul ecx
		mov ecx,100000
		shr edx,16
		mov eax,edx
		mov ebx,edx
		mul ecx
	sub [esp],eax

		mov eax,ebx
		mov ecx,429497
		mov ebx,10

		or eax,eax
		jz >S5

;	#######part 1
		mul ecx
		jc >D1

		mul ebx
		jc >D2

		mul ebx
		jc >D3

		mul ebx
		jc >D4

		mul ebx
		jc >D5
S5:
	pop eax
		mul ecx
		jc >D6

		mul ebx
		jc >D7

		mul ebx
		jc >D8

		mul ebx
		jc >D9

		mul ebx
		jmp >D0

;	#####end part1

D1:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D2:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D3:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D4:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D5:
		add edx,30h
		mov [edi],dl

	pop eax

		mul ecx
		inc edi
D6:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D7:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D8:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D9:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D0:
		add edx,30h
		mov [edi],dx

	mov eax,[dwValue]
	RET
ENDF

a2dw FRAME lpBuffer
	uses esi

	mov esi, [lpBuffer]
	cmp B[esi],"-"
	jne  >S1
		inc esi
		xor eax,eax
		xor edx,edx
		jmp >N1
		:
		lea eax,[eax*4+eax]
		lea eax,[eax*2+edx]
		N1:
		mov dl,[esi]
		inc esi
		sub dl,"0"
		jns <
		neg eax
		ret

	S1:
		xor eax,eax
		xor edx,edx
		jmp >P1
		:
		lea eax,[eax*4+eax]
		lea eax,[eax*2+edx]
		P1:
		mov dl,[esi]
		inc esi
		sub dl,"0"
		jns <
		ret
ENDF

eval_push FRAME p1
	cmp D[StackIndex],STACKSIZE
	jge >.ERROR
		mov ecx,[StackIndex]
		shl ecx,3 // Multiply by 8 (SIZEOF STACKENTRY)
		add ecx,offset StackBuffer
		mov edx,[p1]
		mov eax,[edx+STACKENTRY.var]
		mov [ecx+STACKENTRY.var],eax
		mov eax,[edx+STACKENTRY.sym]
		mov [ecx+STACKENTRY.sym],eax

		inc D[StackIndex]
		mov eax,1
		ret
	.ERROR
	mov eax,0
	ret
endf

eval_pop FRAME p1
	cmp D[StackIndex],0
	jle >>.ERROR
		dec D[StackIndex]
		mov ecx,[StackIndex]
		shl ecx,3 // Multiply by 8 (SIZEOF STACKENTRY)
		add ecx,offset StackBuffer
		mov edx,[p1]

		mov eax,[ecx+STACKENTRY.var]
		mov [edx+STACKENTRY.var],eax
		mov eax,[ecx+STACKENTRY.sym]
		mov [edx+STACKENTRY.sym],eax

		mov eax,1
		ret
	.ERROR
	mov eax,0
	ret
endf

eval_peek FRAME p1
	cmp D[StackIndex],0
	jle >>.ERROR

		mov ecx,[StackIndex]
		dec ecx
		shl ecx,3 // Multiply by 8 (SIZEOF STACKENTRY)
		add ecx,offset StackBuffer
		mov edx,[p1]

		mov eax,[ecx+STACKENTRY.var]
		mov [edx+STACKENTRY.var],eax
		mov eax,[ecx+STACKENTRY.sym]
		mov [edx+STACKENTRY.sym],eax

		mov eax,1
		ret
	.ERROR
	mov eax,0
	ret
endf

eval_initstack:
	push edi
	mov ecx,STACKSIZE
	shl ecx,3
	mov edi,offset StackBuffer
	mov eax,0
	rep stosb
	pop edi
	mov D[StackIndex],0
	ret

eval_binary_op FRAME sym
	LOCAL temp:STACKENTRY

	cmp D[StackIndex],1
	jge >
		mov eax,CALC_FAIL
		ret
	:
	invoke eval_peek,offset temp
	cmp D[temp.sym],CALC_SYMBOL_NUMBER
	je >
		mov eax,CALC_FAIL
		ret
	:
	mov eax,[sym]
	mov [temp.sym],eax
	invoke eval_push,offset temp
	test eax,eax
	jnz >
		mov eax,CALC_FAIL
		ret
	:
	mov eax,CALC_SUCCESS
	ret
endf

eval_unary_op FRAME sym
	LOCAL temp:STACKENTRY

	mov eax,[sym]
	mov [temp.sym],eax

	invoke eval_push,offset temp
	test eax,eax
	jnz >
		mov eax,CALC_FAIL
		ret
	:

	mov eax,CALC_SUCCESS
	ret
endf

eval_paren FRAME sym
	uses ebx
	LOCAL temp:STACKENTRY
	LOCAL result:D

	mov ebx,[sym]
	cmp ebx,CALC_SYMBOL_OPEN
	jne >.CALC_SYMBOL_CLOSE
		mov [temp.sym],ebx
		invoke eval_push,offset temp
		test eax,eax
		jz >>.ERROR
		mov eax,CALC_SUCCESS
		ret

	.CALC_SYMBOL_CLOSE
	cmp ebx,CALC_SYMBOL_CLOSE
	jne >.ERROR
		invoke eval_pop,offset temp
		test eax,eax
		jz >>.ERROR
		cmp D[temp.sym],CALC_SYMBOL_NUMBER
		jne >>.ERROR
		mov eax,[temp.var]
		mov [result],eax
		invoke eval_pop,offset temp
		test eax,eax
		jz >>.ERROR
		cmp D[temp.sym],CALC_SYMBOL_OPEN
		jne >>.ERROR
		invoke eval_number,[result]
		cmp eax,CALC_SUCCESS
		jne >>.ERROR
		mov eax,CALC_SUCCESS
		ret

	.ERROR
	mov eax,CALC_FAIL
	ret
endf

eval_number FRAME num
	uses ebx
	LOCAL temp:STACKENTRY
	LOCAL precede:D // CALC_SYMBOLS
	LOCAL result:D
	
	cmp D[StackIndex],1
	jge >
		mov eax,[num]
		mov [temp.var],eax
		mov D[temp.sym],CALC_SYMBOL_NUMBER
		invoke eval_push,offset temp
		mov eax,CALC_SUCCESS
		ret
	:
	
	invoke eval_peek,offset temp
	mov ebx,[temp.sym]
	mov [precede],ebx
	
	cmp ebx,CALC_SYMBOL_NOT
	jge >>.CALC_SYMBOL_NOT
		// OR,AND,XOR,*,/,+,-
		invoke eval_pop,offset temp
		test eax,eax
		jnz >
			mov eax,CALC_FAIL
			ret
		:
		invoke eval_pop,offset temp
		test eax,eax
		jnz >
			mov eax,CALC_FAIL
			ret
		:
		cmp D[temp.sym],CALC_SYMBOL_NUMBER
		je >
			mov eax,CALC_FAIL
			ret
		:
		// Now the calculation
		cmp ebx,CALC_SYMBOL_OR
		jne >.CALC_SYMBOL_AND
			mov eax,[temp.var]
			mov ecx,[num]
			or eax,ecx
			mov [temp.var],eax
			jmp >>.CALCEND

		.CALC_SYMBOL_AND
		cmp ebx,CALC_SYMBOL_AND
		jne >.CALC_SYMBOL_XOR
			mov eax,[temp.var]
			mov ecx,[num]
			and eax,ecx
			mov [temp.var],eax
			jmp >>.CALCEND
		
		.CALC_SYMBOL_XOR
		cmp ebx,CALC_SYMBOL_XOR
		jne >.CALC_SYMBOL_MULTIPLY
			mov eax,[temp.var]
			mov ecx,[num]
			xor eax,ecx
			mov [temp.var],eax
			jmp >>.CALCEND
		
		.CALC_SYMBOL_MULTIPLY
		cmp ebx,CALC_SYMBOL_MULTIPLY
		jne >.CALC_SYMBOL_DIVIDE
			mov eax,[temp.var]
			mov ecx,[num]
			xor edx,edx
			#IFDEF SIGNEDOP
				imul eax,ecx
			#ELSE
				mul ecx
			#ENDIF
			test edx,edx
			jz >
				mov eax,CALC_OVERFLOW
				ret
			:
			mov [temp.var],eax
			jmp >>.CALCEND

		.CALC_SYMBOL_DIVIDE
		cmp ebx,CALC_SYMBOL_DIVIDE
		jne >>.CALC_SYMBOL_ADD
			cmp D[num],0
			jne >
				mov eax,CALC_DIVBYZERO
				ret
			:
			mov eax,[temp.var]
			mov ecx,[num]
			xor edx,edx
			#IFDEF SIGNEDOP
			idiv ecx
			#ELSE
			div ecx
			#ENDIF
			mov [temp.var],eax
			jmp >>.CALCEND

		.CALC_SYMBOL_ADD
		cmp ebx,CALC_SYMBOL_ADD
		jne >.CALC_SYMBOL_SUBTRACT
			mov eax,[temp.var]
			mov ecx,[num]
			add eax,ecx
			mov [temp.var],eax
			jmp >>.CALCEND

		.CALC_SYMBOL_SUBTRACT
		cmp ebx,CALC_SYMBOL_SUBTRACT
		jne >>.DEFAULT
			mov eax,[temp.var]
			mov ecx,[num]
			sub eax,ecx
			mov [temp.var],eax
			jmp >>.CALCEND

		.CALCEND
			// Push the result onto the stack
			mov D[temp.sym],CALC_SYMBOL_NUMBER
			invoke eval_push,offset temp
			test eax,eax
			jnz >
				mov eax,CALC_FAIL
				ret
			:
			mov eax,CALC_SUCCESS
			ret

	.CALC_SYMBOL_NOT
	cmp ebx,CALC_SYMBOL_NOT
	jne >>.CALC_SYMBOL_OPEN
		invoke eval_pop,offset temp
		mov D[result],TRUE
		cmp D[num],0
		je >
			mov D[result],FALSE
		:
		invoke eval_number,[result]
		ret

	.CALC_SYMBOL_OPEN
	cmp ebx,CALC_SYMBOL_OPEN
	jne >>.CALC_SYMBOL_CLOSE
		mov eax,[num]
		mov [temp.var],eax
		mov D[temp.sym],CALC_SYMBOL_NUMBER
		invoke eval_push,offset temp
		test eax,eax
		jnz >
			mov eax,CALC_FAIL
			ret
		:
		mov eax,CALC_SUCCESS
		ret

	.CALC_SYMBOL_CLOSE
	cmp ebx,CALC_SYMBOL_CLOSE
	jne >>.CALC_SYMBOL_NUMBER
		// Not possible
		mov eax,CALC_FAIL
		ret

	.CALC_SYMBOL_NUMBER
	cmp ebx,CALC_SYMBOL_NUMBER
	jne >>.DEFAULT
		// Not possible
		mov eax,CALC_FAIL
		ret

	.DEFAULT
		mov eax,CALC_FAIL
		ret

	ret
endf

calculate FRAME exp,result
	uses edi,esi,ebx
	LOCAL temp:STACKENTRY
	LOCAL szNumber[64]:B

	call eval_initstack
	
	mov edi,[exp]
	test edi,edi
	jnz >
		// bad pointer return 0
		mov eax,0
		ret
	:
	mov eax,[edi]
	test eax,eax
	jnz >
		// empty string
		mov eax,0
		ret
	:
	// set the index to zero
	xor ebx,ebx
	dec ebx
	.WALKEXPRESSION
		inc ebx
		mov esi,[edi+ebx]
		and esi,0xff
		test esi,esi
		jz >>.ENDWALK

		.OR
		cmp esi,'|'
		jne >>.AND
			invoke eval_binary_op,CALC_SYMBOL_OR
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			// If it fails return the index
			mov eax,ebx
			ret

		.AND
		cmp esi,'&'
		jne >>.XOR
			invoke eval_binary_op,CALC_SYMBOL_AND
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret
		
		.XOR
		cmp esi,'^'
		jne >>.NOT
			invoke eval_binary_op,CALC_SYMBOL_XOR
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret
		
		.NOT
		cmp esi,'!'
		jne >>.OPEN
			invoke eval_unary_op,CALC_SYMBOL_NOT
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret
		
		.OPEN
		cmp esi,'('
		jne >>.CLOSE
			invoke eval_paren,CALC_SYMBOL_OPEN
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret
		
		.CLOSE
		cmp esi,')'
		jne >>.MULTIPLY
			invoke eval_paren,CALC_SYMBOL_CLOSE
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret
		
		.MULTIPLY
		cmp esi,'*'
		jne >>.DIVIDE
			invoke eval_binary_op,CALC_SYMBOL_MULTIPLY
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret
		
		.DIVIDE
		cmp esi,'/'
		jne >>.ADD
			invoke eval_binary_op,CALC_SYMBOL_DIVIDE
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret
		
		.ADD
		cmp esi,'+'
		jne >>.SUBTRACT
			invoke eval_binary_op,CALC_SYMBOL_ADD
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret
		
		.SUBTRACT
		cmp esi,'-'
		jne >>.SPACE
			cmp D[StackIndex],0
			je >>.NUMBER
			invoke eval_peek,offset temp
			cmp D[temp.sym],CALC_SYMBOL_NUMBER
			jne >>.NUMBER
			invoke eval_binary_op,CALC_SYMBOL_SUBTRACT
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret
		
		.SPACE
		cmp esi," "
		je <<.WALKEXPRESSION

		.TAB
		cmp esi,9
		je <<.WALKEXPRESSION

		.NUMBER
			mov eax,offset szNumber
			cmp esi,"-"
			jne >
				mov B[eax],"-"
				inc eax
				inc ebx
				mov esi,[edi+ebx]
				and esi,0xff
			:
			cmp esi,0x30
			jl >>.INVALID
			cmp esi,0x39
			jg >>.INVALID
			// we have a number copy it to the buffer
				:
				mov cl,[edi+ebx]
				cmp cl,0x39
				jg >
				cmp cl,0x30
				jl >
				mov [eax],cl
				inc ebx
				inc eax
				jmp <
				:
			dec ebx
			mov B[eax],0
			invoke a2dw,offset szNumber
			invoke eval_number,eax
			cmp eax,CALC_SUCCESS
			
			je <<.WALKEXPRESSION
			mov ecx,[result]
			mov D[ecx],eax
			mov eax,ebx
			ret

		.INVALID
			mov eax,ebx
			ret

	.ENDWALK
	cmp D[StackIndex],1
	je >
		mov eax,ebx
		ret
	:
	invoke eval_pop,offset temp
	test eax,eax
	jnz >
		mov eax,ebx
		ret
	:
	cmp D[temp.sym],CALC_SYMBOL_NUMBER
	je >
		mov eax,ebx
		ret
	:
	mov eax,[result]
	mov ecx,[temp.var]
	mov [eax],ecx
	mov eax,CALC_SUCCESS
	ret
endf
